Educational Codeforces Round 64 (Rated for Div. 2) B Ugly pairs

  • 题目

You are given a string, consisting of lowercase Latin letters.

A pair of neighbouring letters in a string is considered ugly if these letters are also neighbouring in a alphabet. For example, string "abaca" contains ugly pairs at positions (1,2)(1,2) — "ab" and (2,3)(2,3) — "ba". Letters 'a' and 'z' aren't considered neighbouring in a alphabet.

Can you rearrange the letters of a given string so that there are no ugly pairs? You can choose any order of the letters of the given string but you can't add any new letters or remove the existing ones. You can also leave the order the same.

If there are multiple answers, print any of them.

You also have to answer TT separate queries.

Input

The first line contains a single integer TT (1≤T≤1001≤T≤100) — the number of queries.

Each of the next TT lines contains string ss (1≤|s|≤100)(1≤|s|≤100) — the string for the next query. It is guaranteed that it contains only lowercase Latin letters.

Note that in hacks you have to set T=1T=1.

Output

Print TT lines. The ii-th line should contain the answer to the ii-th query.

If the answer for the ii-th query exists, then print such a rearrangment of letters of the given string that it contains no ugly pairs. You can choose any order of the letters of the given string but you can't add any new letters or remove the existing ones. You can also leave the order the same.

If there are multiple answers, print any of them.

Otherwise print "No answer" for that query.


  • 题意

给出N个小写字母, 重新排列使得不存在有相邻的只相差1的字母, 不存在输出No answer

  • 分析

开始,十分固执地认为这道题是dfs。因为这道Zipper 记忆化搜索或者DP

然后,觉得DFS从哪开始呢?然后就翻了题解。发现有奇数,偶数的讨论。立马就明白了。

贪心的想法:26个字母,按照字母表的顺序,分成奇数位,偶数位。奇数放在一起,一定不会出现丑对。偶数放在一起,也一定不会出现丑对。只要看是  奇数+偶数   or  偶数+奇数。

又去看了看别人的代码,自己的代码真是又臭又长。orz

完全没有必要判断的这么麻烦嘛。


  • 又臭又长的代码

甚至因为multiset.end()的指向位置而WA了一次。

//AC
#include
#include
#include
#include
#include
#include
#include
#include
#include
using namespace std;
#define ll long long
multiset qi;
multiset ou;
multiset ::iterator it;
multiset ::iterator it2;
int main()
{
    int t;
    scanf("%d",&t);
    while(t--)
    {
        qi.clear(); ou.clear();
        string s;  cin>>s;

        for(int i=0;i
  • 欣赏大佬的代码

https://blog.csdn.net/a1097304791/article/details/89785158

使用字符串,判断时,只需要判断两个字符的差的绝对值是否不等于1.

开一个num[]数组,来记录每一个字母出现了多少次。与我的multiset相同作用。


#define ms(x, n) memset(x,n,sizeof(x));
typedef  long long LL;
const int inf = 1<<30;
const LL maxn = 1e5+10;

int main()
{
    int T, num[30];
    string s, s1, s2;
    cin >> T;
    while(T--){
        ms(num, 0); s1 = s2 = "";
        cin >> s;
        for(int i = 0; i < s.length(); i++)
            ++num[s[i]-'a'];
        for(int i = 0; i < 26; i+=2)
            while(num[i]--) s1 += ('a'+i);
        for(int i = 1; i < 26; i+=2)
            while(num[i]--) s2 += ('a'+i);

        if(abs(s1.back()-s2.front())!=1) cout << s1 << s2 << endl;
        else if(abs(s2.back()-s1.front())!=1) cout << s2 << s1 << endl;
        else cout << "No answer" << endl;
    }

	return 0;
}

 

你可能感兴趣的:(#,贪心,#,字符串,#,记忆化搜索)